/*
 *
 * GLU Constants
 *
 */

typedef struct t_ioGLU_constTable {
	char *name;
	int value;
} t_ioGLU_constTable;


t_ioGLU_constTable ioGLU_constTable[] = {

/* Boolean */
	{"GLU_FALSE",GLU_FALSE},
	{"GLU_TRUE",GLU_TRUE},

/* Version */
	{"GLU_VERSION_1_1",GLU_VERSION_1_1},

	{"GLU_VERSION_1_2",GLU_VERSION_1_2},

#ifdef GLU_VERSION_1_3
	{"GLU_VERSION_1_3",GLU_VERSION_1_3},
#endif

/* StringName */
	{"GLU_VERSION",GLU_VERSION},
	{"GLU_EXTENSIONS",GLU_EXTENSIONS},

/* ErrorCode */
#ifdef GLU_ERROR
	{"GLU_ERROR",GLU_ERROR},
#endif
	{"GLU_INVALID_ENUM",GLU_INVALID_ENUM},
	{"GLU_INVALID_VALUE",GLU_INVALID_VALUE},
	{"GLU_OUT_OF_MEMORY",GLU_OUT_OF_MEMORY},
#ifdef _WIN32
	#define GLU_INVALID_OPERATION              100904
#endif

	{"GLU_INVALID_OPERATION",GLU_INVALID_OPERATION},

/* NurbsDisplay */
	{"GLU_OUTLINE_POLYGON",GLU_OUTLINE_POLYGON},
	{"GLU_OUTLINE_PATCH",GLU_OUTLINE_PATCH},



#ifdef GLU_NURBS_ERROR
/* NurbsCallback */
	{"GLU_NURBS_ERROR",GLU_NURBS_ERROR},
	{"GLU_NURBS_BEGIN",GLU_NURBS_BEGIN},
	{"GLU_NURBS_BEGIN_EXT",GLU_NURBS_BEGIN_EXT},
	{"GLU_NURBS_VERTEX",GLU_NURBS_VERTEX},
	{"GLU_NURBS_VERTEX_EXT",GLU_NURBS_VERTEX_EXT},
	{"GLU_NURBS_NORMAL",GLU_NURBS_NORMAL},
	{"GLU_NURBS_NORMAL_EXT",GLU_NURBS_NORMAL_EXT},
	{"GLU_NURBS_COLOR",GLU_NURBS_COLOR},
	{"GLU_NURBS_COLOR_EXT",GLU_NURBS_COLOR_EXT},
	{"GLU_NURBS_TEXTURE_COORD",GLU_NURBS_TEXTURE_COORD},
	{"GLU_NURBS_TEX_COORD_EXT",GLU_NURBS_TEX_COORD_EXT},
	{"GLU_NURBS_END",GLU_NURBS_END},
	{"GLU_NURBS_END_EXT",GLU_NURBS_END_EXT},
	{"GLU_NURBS_BEGIN_DATA",GLU_NURBS_BEGIN_DATA},
	{"GLU_NURBS_BEGIN_DATA_EXT",GLU_NURBS_BEGIN_DATA_EXT},
	{"GLU_NURBS_VERTEX_DATA",GLU_NURBS_VERTEX_DATA},
	{"GLU_NURBS_VERTEX_DATA_EXT",GLU_NURBS_VERTEX_DATA_EXT},
	{"GLU_NURBS_NORMAL_DATA",GLU_NURBS_NORMAL_DATA},
	{"GLU_NURBS_NORMAL_DATA_EXT",GLU_NURBS_NORMAL_DATA_EXT},
	{"GLU_NURBS_COLOR_DATA",GLU_NURBS_COLOR_DATA},
	{"GLU_NURBS_COLOR_DATA_EXT",GLU_NURBS_COLOR_DATA_EXT},
	{"GLU_NURBS_TEXTURE_COORD_DATA",GLU_NURBS_TEXTURE_COORD_DATA},
	{"GLU_NURBS_TEX_COORD_DATA_EXT",GLU_NURBS_TEX_COORD_DATA_EXT},
	{"GLU_NURBS_END_DATA",GLU_NURBS_END_DATA},
	{"GLU_NURBS_END_DATA_EXT",GLU_NURBS_END_DATA_EXT},

/* NurbsError */
	{"GLU_NURBS_ERROR1",GLU_NURBS_ERROR1},
	{"GLU_NURBS_ERROR2",GLU_NURBS_ERROR2},
	{"GLU_NURBS_ERROR3",GLU_NURBS_ERROR3},
	{"GLU_NURBS_ERROR4",GLU_NURBS_ERROR4},
	{"GLU_NURBS_ERROR5",GLU_NURBS_ERROR5},
	{"GLU_NURBS_ERROR6",GLU_NURBS_ERROR6},
	{"GLU_NURBS_ERROR7",GLU_NURBS_ERROR7},
	{"GLU_NURBS_ERROR8",GLU_NURBS_ERROR8},
	{"GLU_NURBS_ERROR9",GLU_NURBS_ERROR9},
	{"GLU_NURBS_ERROR10",GLU_NURBS_ERROR10},
	{"GLU_NURBS_ERROR11",GLU_NURBS_ERROR11},
	{"GLU_NURBS_ERROR12",GLU_NURBS_ERROR12},
	{"GLU_NURBS_ERROR13",GLU_NURBS_ERROR13},
	{"GLU_NURBS_ERROR14",GLU_NURBS_ERROR14},
	{"GLU_NURBS_ERROR15",GLU_NURBS_ERROR15},
	{"GLU_NURBS_ERROR16",GLU_NURBS_ERROR16},
	{"GLU_NURBS_ERROR17",GLU_NURBS_ERROR17},
	{"GLU_NURBS_ERROR18",GLU_NURBS_ERROR18},
	{"GLU_NURBS_ERROR19",GLU_NURBS_ERROR19},
	{"GLU_NURBS_ERROR20",GLU_NURBS_ERROR20},
	{"GLU_NURBS_ERROR21",GLU_NURBS_ERROR21},
	{"GLU_NURBS_ERROR22",GLU_NURBS_ERROR22},
	{"GLU_NURBS_ERROR23",GLU_NURBS_ERROR23},
	{"GLU_NURBS_ERROR24",GLU_NURBS_ERROR24},
	{"GLU_NURBS_ERROR25",GLU_NURBS_ERROR25},
	{"GLU_NURBS_ERROR26",GLU_NURBS_ERROR26},
	{"GLU_NURBS_ERROR27",GLU_NURBS_ERROR27},
	{"GLU_NURBS_ERROR28",GLU_NURBS_ERROR28},
	{"GLU_NURBS_ERROR29",GLU_NURBS_ERROR29},
	{"GLU_NURBS_ERROR30",GLU_NURBS_ERROR30},
	{"GLU_NURBS_ERROR31",GLU_NURBS_ERROR31},
	{"GLU_NURBS_ERROR32",GLU_NURBS_ERROR32},
	{"GLU_NURBS_ERROR33",GLU_NURBS_ERROR33},
	{"GLU_NURBS_ERROR34",GLU_NURBS_ERROR34},
	{"GLU_NURBS_ERROR35",GLU_NURBS_ERROR35},
	{"GLU_NURBS_ERROR36",GLU_NURBS_ERROR36},
	{"GLU_NURBS_ERROR37",GLU_NURBS_ERROR37},

/* NurbsProperty */
	{"GLU_AUTO_LOAD_MATRIX",GLU_AUTO_LOAD_MATRIX},
	{"GLU_CULLING",GLU_CULLING},
	{"GLU_SAMPLING_TOLERANCE",GLU_SAMPLING_TOLERANCE},
	{"GLU_DISPLAY_MODE",GLU_DISPLAY_MODE},
	{"GLU_PARAMETRIC_TOLERANCE",GLU_PARAMETRIC_TOLERANCE},
	{"GLU_SAMPLING_METHOD",GLU_SAMPLING_METHOD},
	{"GLU_U_STEP",GLU_U_STEP},
	{"GLU_V_STEP",GLU_V_STEP},
	{"GLU_NURBS_MODE",GLU_NURBS_MODE},
	{"GLU_NURBS_MODE_EXT",GLU_NURBS_MODE_EXT},
	{"GLU_NURBS_TESSELLATOR",GLU_NURBS_TESSELLATOR},
	{"GLU_NURBS_TESSELLATOR_EXT",GLU_NURBS_TESSELLATOR_EXT},
	{"GLU_NURBS_RENDERER",GLU_NURBS_RENDERER},
	{"GLU_NURBS_RENDERER_EXT",GLU_NURBS_RENDERER_EXT},

/* NurbsSampling */
	{"GLU_OBJECT_PARAMETRIC_ERROR",GLU_OBJECT_PARAMETRIC_ERROR},
	{"GLU_OBJECT_PARAMETRIC_ERROR_EXT",GLU_OBJECT_PARAMETRIC_ERROR_EXT},
	{"GLU_OBJECT_PATH_LENGTH",GLU_OBJECT_PATH_LENGTH},
	{"GLU_OBJECT_PATH_LENGTH_EXT",GLU_OBJECT_PATH_LENGTH_EXT},

	{"GLU_PATH_LENGTH",GLU_PATH_LENGTH},
	{"GLU_PARAMETRIC_ERROR",GLU_PARAMETRIC_ERROR},
	{"GLU_DOMAIN_DISTANCE",GLU_DOMAIN_DISTANCE},

/* NurbsTrim */
	{"GLU_MAP1_TRIM_2",GLU_MAP1_TRIM_2},
	{"GLU_MAP1_TRIM_3",GLU_MAP1_TRIM_3},

#endif

/* QuadricDrawStyle */
	{"GLU_POINT",GLU_POINT},
	{"GLU_LINE",GLU_LINE},
	{"GLU_FILL",GLU_FILL},
	{"GLU_SILHOUETTE",GLU_SILHOUETTE},

/* QuadricCallback */

/* QuadricNormal */
	{"GLU_SMOOTH",GLU_SMOOTH},
	{"GLU_FLAT",GLU_FLAT},
	{"GLU_NONE",GLU_NONE},

/* QuadricOrientation */
	{"GLU_OUTSIDE",GLU_OUTSIDE},
	{"GLU_INSIDE",GLU_INSIDE},

/* TessCallback */
	{"GLU_TESS_BEGIN",GLU_TESS_BEGIN},
	{"GLU_BEGIN",GLU_BEGIN},
	{"GLU_TESS_VERTEX",GLU_TESS_VERTEX},
	{"GLU_VERTEX",GLU_VERTEX},
	{"GLU_TESS_END",GLU_TESS_END},
	{"GLU_END",GLU_END},
	{"GLU_TESS_ERROR",GLU_TESS_ERROR},
	{"GLU_TESS_EDGE_FLAG",GLU_TESS_EDGE_FLAG},
	{"GLU_EDGE_FLAG",GLU_EDGE_FLAG},
	{"GLU_TESS_COMBINE",GLU_TESS_COMBINE},
	{"GLU_TESS_BEGIN_DATA",GLU_TESS_BEGIN_DATA},
	{"GLU_TESS_VERTEX_DATA",GLU_TESS_VERTEX_DATA},
	{"GLU_TESS_END_DATA",GLU_TESS_END_DATA},
	{"GLU_TESS_ERROR_DATA",GLU_TESS_ERROR_DATA},
	{"GLU_TESS_EDGE_FLAG_DATA",GLU_TESS_EDGE_FLAG_DATA},
	{"GLU_TESS_COMBINE_DATA",GLU_TESS_COMBINE_DATA},

/* TessContour */
	{"GLU_CW",GLU_CW},
	{"GLU_CCW",GLU_CCW},
	{"GLU_INTERIOR",GLU_INTERIOR},
	{"GLU_EXTERIOR",GLU_EXTERIOR},
	{"GLU_UNKNOWN",GLU_UNKNOWN},

/* TessProperty */
	{"GLU_TESS_WINDING_RULE",GLU_TESS_WINDING_RULE},
	{"GLU_TESS_BOUNDARY_ONLY",GLU_TESS_BOUNDARY_ONLY},
	{"GLU_TESS_TOLERANCE",GLU_TESS_TOLERANCE},

/* TessError */
	{"GLU_TESS_ERROR1",GLU_TESS_ERROR1},
	{"GLU_TESS_ERROR2",GLU_TESS_ERROR2},
	{"GLU_TESS_ERROR3",GLU_TESS_ERROR3},
	{"GLU_TESS_ERROR4",GLU_TESS_ERROR4},
	{"GLU_TESS_ERROR5",GLU_TESS_ERROR5},
	{"GLU_TESS_ERROR6",GLU_TESS_ERROR6},
	{"GLU_TESS_ERROR7",GLU_TESS_ERROR7},
	{"GLU_TESS_ERROR8",GLU_TESS_ERROR8},
	{"GLU_TESS_MISSING_BEGIN_POLYGON",GLU_TESS_MISSING_BEGIN_POLYGON},
	{"GLU_TESS_MISSING_BEGIN_CONTOUR",GLU_TESS_MISSING_BEGIN_CONTOUR},
	{"GLU_TESS_MISSING_END_POLYGON",GLU_TESS_MISSING_END_POLYGON},
	{"GLU_TESS_MISSING_END_CONTOUR",GLU_TESS_MISSING_END_CONTOUR},
	{"GLU_TESS_COORD_TOO_LARGE",GLU_TESS_COORD_TOO_LARGE},
	{"GLU_TESS_NEED_COMBINE_CALLBACK",GLU_TESS_NEED_COMBINE_CALLBACK},

/* TessWinding */
	{"GLU_TESS_WINDING_ODD",GLU_TESS_WINDING_ODD},
	{"GLU_TESS_WINDING_NONZERO",GLU_TESS_WINDING_NONZERO},
	{"GLU_TESS_WINDING_POSITIVE",GLU_TESS_WINDING_POSITIVE},
	{"GLU_TESS_WINDING_NEGATIVE",GLU_TESS_WINDING_NEGATIVE},
	{"GLU_TESS_WINDING_ABS_GEQ_TWO",GLU_TESS_WINDING_ABS_GEQ_TWO},

	/* The end */
	{NULL,0},
};

